Package com.macrofocus.high_d.parallelcoordinates

# Class AbstractParallelCoordinatesComponent<Component,Color,Row,C>

java.lang.Object
com.macrofocus.high_d.parallelcoordinates.AbstractParallelCoordinatesComponent<Component,Color,Row,C>

All Implemented Interfaces:
  `com.macrofocus.crossplatform.CPComponent<Component>`, `ParallelCoordinatesComponent<Component,Color,Row,C>`

Direct Known Subclasses:
  `JavaFXParallelCoordinatesComponent`

public abstract class AbstractParallelCoordinatesComponent<Component,Color,Row,C> extends Object implements ParallelCoordinatesComponent<Component,Color,Row,C>

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `class`
  `AbstractParallelCoordinatesComponent.AbstractVisualLayerIDrawing`
  `class`
  `AbstractParallelCoordinatesComponent.Cache`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected final com.macrofocus.crossplatform.CPCanvas`
  `canvas`
  `protected final int`
  `level`
  `protected ParallelCoordinatesModel<Color,Row,C>`
  `model`
  `protected final CPTimer`
  `timer`
  `protected final ParallelCoordinatesView<Component,com.macrofocus.igraphics.CPColor,Row,C>`
  `view`

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `AbstractParallelCoordinatesComponent(ParallelCoordinatesView view, com.macrofocus.crossplatform.CPCanvas canvas, com.macrofocus.crossplatform.CPFactory<?,?,?,Color> factory, int level)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `clearCache()`
  `void`
  `createOverplots()`
  `static double`
  `distance(double x1, double y1, double x2, double y2)`
  Computes the euclidean distance between (x1,y1) and (x2,y2)
  `Row`
  `getClosestRow(int x, int y)`
  `protected abstract int`
  `getHeight()`
  `List<Row>`
  `getRows(com.macrofocus.geom.Rectangle2D r)`
  `protected com.macrofocus.geom.Shape`
  `getShape(int layer, Object row, int level)`
  `protected abstract int`
  `getWidth()`
  `protected abstract void`
  `refresh()`
  `protected abstract void`
  `repaint()`
  `void`
  `setModel(ParallelCoordinatesModel<Color,Row,C> model)`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface com.macrofocus.crossplatform.CPComponent

  `setStyleClass`

  ### Methods inherited from interface com.macrofocus.high_d.parallelcoordinates.ParallelCoordinatesComponent

  `getNativeComponent, reset, scheduleUpdate, waitUntilReady`

- ## Field Details

  - ### model

    protected ParallelCoordinatesModel<Color,Row,C> model

  - ### level

    protected final int level

  - ### canvas

    protected final com.macrofocus.crossplatform.CPCanvas canvas

  - ### view

    protected final ParallelCoordinatesView<Component,com.macrofocus.igraphics.CPColor,Row,C> view

  - ### timer

    protected final CPTimer timer

- ## Constructor Details

  - ### AbstractParallelCoordinatesComponent

    protected AbstractParallelCoordinatesComponent(ParallelCoordinatesView view, com.macrofocus.crossplatform.CPCanvas canvas, com.macrofocus.crossplatform.CPFactory<?,?,?,Color> factory, int level)

- ## Method Details

  - ### getWidth

    protected abstract int getWidth()

  - ### getHeight

    protected abstract int getHeight()

  - ### refresh

    protected abstract void refresh()

  - ### repaint

    protected abstract void repaint()

  - ### setModel

    public void setModel(ParallelCoordinatesModel<Color,Row,C> model)
    Specified by:
      `setModel` in interface `ParallelCoordinatesComponent<Component,Color,Row,C>`

  - ### createOverplots

    public void createOverplots()
    Specified by:
      `createOverplots` in interface `ParallelCoordinatesComponent<Component,Color,Row,C>`

  - ### getShape

    protected com.macrofocus.geom.Shape getShape(int layer, Object row, int level)

  - ### clearCache

    public void clearCache()
    Specified by:
      `clearCache` in interface `ParallelCoordinatesComponent<Component,Color,Row,C>`

  - ### getClosestRow

    public Row getClosestRow(int x, int y)
    Specified by:
      `getClosestRow` in interface `ParallelCoordinatesComponent<Component,Color,Row,C>`

  - ### getRows

    public List<Row> getRows(com.macrofocus.geom.Rectangle2D r)
    Specified by:
      `getRows` in interface `ParallelCoordinatesComponent<Component,Color,Row,C>`

  - ### distance

    public static double distance(double x1, double y1, double x2, double y2)
    Computes the euclidean distance between (x1,y1) and (x2,y2)
    Parameters:
      `x1` -
      `y1` -
      `x2` -
      `y2` -
    Returns:
      euclidean distance between (x1,y1) and (x2,y2)